-- frmMain.lua
-- written by Habna


resources = {
	  LeftBubble_TopLeftCorner = { Background = AppRes.."lbubble_top_left_corner.tga" },
	  LeftBubble_TopRightCorner = { Background = AppRes.."lbubble_top_right_corner.tga" },
	  Bubble_MidLeft = { Background = AppRes.."bubble_mid_left.tga" },
	  Bubble_BotLeftCorner = { Background = AppRes.."bubble_bot_left_corner.tga" },
	  Bubble_Top = { Background = AppRes.."bubble_top.tga" },
	  Bubble_Bot = { Background = AppRes.."bubble_bot.tga" },
	  Bubble_Mid = { Background = AppRes.."bubble_mid.tga" },
	  Bubble_MidRight = { Background = AppRes.."bubble_mid_right.tga" },
	  Bubble_BotRightCorner = { Background = AppRes.."bubble_bot_right_corner.tga" },

	  RightBubble_TopLeftCorner = { Background = AppRes.."rbubble_top_left_corner.tga" },
	  RightBubble_TopRightCorner = { Background = AppRes.."rbubble_top_right_corner.tga" },

	  Ring = { Background = AppRes.."ring.tga" },
	  Picker = { Background = AppRes.."picker.jpg" }
};

function frmMain()
	--**v Check if TitanBar Reloader is loaded v**
	Turbine.PluginManager.RefreshAvailablePlugins();
	loaded_plugins = Turbine.PluginManager.GetLoadedPlugins();

	TBRChecker = Turbine.UI.Control();
	TBRChecker:SetWantsUpdates( true );
	
	TBRChecker.Update = function( sender, args )
		for k,v in pairs(loaded_plugins) do
			if v.Name == "TitanBar Reloader" then
				Turbine.PluginManager.UnloadScriptState( 'TitanBarReloader' );
				--break;
			end
			if v.Name == "TitanBar Unloader" then
				Turbine.PluginManager.UnloadScriptState( 'TitanBarUnloader' );
				--break;
			end
		end
		TBRChecker:SetWantsUpdates( false );
	end
	--**^

	ToolTipWin = nil;

	wTitanBar = Turbine.UI.Window();
	wTitanBar:SetPosition( 0, 0 );
	wTitanBar:SetSize( screenWidth, 30 );
	--wTitanBar:SetBackground( resources.TitanBar.Background );
	wTitanBar:SetBackColor( Turbine.UI.Color( bcAlpha, bcRed, bcGreen, bcBlue ) );
	--wTitanBar:SetMouseVisible( false ); -- If set to false, menu will not work.
	wTitanBar:SetWantsKeyEvents( true );
	wTitanBar:SetZOrder( 10 );
	wTitanBar:SetVisible( true );

	--**v Get player backpack, Class, Race & attributes v**
	if pcall( Turbine.Gameplay.LocalPlayer.GetInstance ) then
		Player = Turbine.Gameplay.LocalPlayer.GetInstance();
	else
		Player = Turbine.Gameplay.LocalPlayer;
	end
	
	--Client will crash if :GetAttributes is called and then the plugin is unloaded
	--PlayerAtt = Player:GetAttributes();
	--**^
	
	-- 0x41007ed2 (Mail in game icon) or 0x41007f7a

	-- 0x41007eca (Poor server connection)
	-- 0x41007ecb (Broken server connection)
	-- 0x41007ecc (Good server connection)

	
	--**v TitanBar event handlers v**
	wTitanBar.KeyDown = function( sender, args )
		if ( args.Action == 268435635 ) then -- **v Hide TitanBar if F12 key is press v**
			wTitanBar:SetVisible( not wTitanBar:IsVisible() );
		end
	end

	wTitanBar.MouseLeave = function( sender, args )
		if ToolTipWin ~= nil then
			ToolTipWin:SetVisible( false );
			ToolTipWin = nil;
		end
	end

	wTitanBar.MouseClick = function( sender, args )
		if ( args.Button == Turbine.UI.MouseButton.Right ) then
			mouseXPos, mouseYPos = Turbine.UI.Display.GetMousePosition();
			_G.sFromCtr = "TitanBar";
			TitanBarMenu:ShowMenu();
		elseif ( args.Button == Turbine.UI.MouseButton.Left ) then
			
		end
	end

	wTitanBar.Unload = function( sender, args )
		if ShowMoney then RemoveCallback(PlayerAtt, "MoneyChanged", wTitanBar.moneyChangedHandler); end
		if ShowDestinyPoints then RemoveCallback(PlayerAtt, "DestinyPointsChanged", wTitanBar.dpChangedHandler); end
		if ShowBagInfos then RemoveCallback(Backpack, "ItemAdded", wTitanBar.iaHandler); end
		if ShowBagInfos then RemoveCallback(Backpack, "ItemRemoved", wTitanBar.irHandler);	end
		if ShowPlayerInfos then RemoveCallback(Player, "LevelChanged", wTitanBar.levelChangedHandler); end
		if ShowPlayerInfos then RemoveCallback(Player, "NameChanged", wTitanBar.nameChangedHandler); end
		if ShowGameTime then RemoveCallback(Turbine.Engine.GetDate(), "TimeChanged", wTitanBar.gtChangedHandler); end
	end
	--**^ Window event handlers ^**

	import (AppCtrD.."MoneyInfos");
	C["MICtr"]:SetVisible( ShowMoney );
	if ShowMoney then
		PlayerAtt = Player:GetAttributes();
		wTitanBar.moneyChangedHandler = AddCallback(PlayerAtt, "MoneyChanged", function(sender, args) UpdateMoney(); end);
		--import (AppDirD.."MoneyInfos");
		UpdateMoney();
	end

	import (AppCtrD.."DestinyPoints");
	C["DPCtr"]:SetVisible( ShowDestinyPoints );
	if ShowDestinyPoints then
		PlayerAtt = Player:GetAttributes();
		wTitanBar.dpChangedHandler = AddCallback(PlayerAtt, "DestinyPointsChanged", function(sender, args) UpdateDestinyPoints(); end);
		--import (AppDirD.."DestinyPoints");
		UpdateDestinyPoints();
	end

	import (AppCtrD.."BagInfos");
	C["BICtr"]:SetVisible( ShowBagInfos );
	if ShowBagInfos then
		Backpack = Player:GetBackpack();
		wTitanBar.iaHandler = AddCallback(Backpack, "ItemAdded", function(sender, args) UpdateBackpackInfos(); end);
		wTitanBar.irHandler = AddCallback(Backpack, "ItemRemoved", function(sender, args) UpdateBackpackInfos(); end);
		--import (AppDirD.."BagInfos");
		UpdateBackpackInfos();
	end

	import (AppCtrD.."PlayerInfos");
	C["PICtr"]:SetVisible( ShowPlayerInfos );
	if ShowPlayerInfos then
		wTitanBar.levelChangedHandler = AddCallback(Player, "LevelChanged", function(sender, args) C["PLvl"]:SetText( Player:GetLevel() ); end);
		wTitanBar.nameChangedHandler = AddCallback(Player, "NameChanged", function(sender, args) C["PName"]:SetText( Player:GetName() ); end);
		--import (AppCtrD.."PlayerInfos");
		UpdatePlayersInfos();
	end

	import (AppCtrD.."GameTime");
	C["GTCtr"]:SetVisible( ShowGameTime );
	if ShowGameTime then
		--wTitanBar.gtChangedHandler = AddCallback(Turbine.Engine.GetDate(), "TimeChanged", function(sender, args) UpdateGameTime(); end);
		--import (AppCtrD.."GameTime");
		UpdateGameTime();
		C["GTTimer"]:SetWantsUpdates( true );
	end
	
	ReplaceModuleLocation();
end
-- **^